<div class="row">
    <div class="col-md-12">
        <button data-toggle="modal" data-target="#addNewEmployee" type="button" class="btn btn-sm btn-custom mb-3"
        data-backdrop="static" data-keyboard="false" (click)="createNewEmployeeForm()">New Employee</button>
    </div>
</div>
<div class="card shadow mb-4">
    <div class="card-header">
        <form class="user filterForm" [formGroup]="filterForm">
            <div class="form-group row">
                <div *ngIf="userRole == ADMIN" class="col-sm-2 mb-3 mb-sm-0">
                    <select formControlName="company" class="form-control dropdown"
                        (change)="getEmployees()">
                        <option value="" selected>Select Company</option>
                        <option *ngFor="let company of companies" value="{{company.company_id}}">{{company.name}}
                        </option>
                    </select>
                </div>
                <div *ngIf="userRole == ADMIN" class="col-sm-2 mb-3 mb-sm-0">
                    <select formControlName="company" class="form-control dropdown"
                        (change)="getEmployees()">
                        <option value="" selected>Select Company</option>
                        <option *ngFor="let company of companies" value="{{company.company_id}}">{{company.name}}
                        </option>
                    </select>
                </div>
                <div class="col-sm-2 mb-3 mb-sm-0" *ngIf="userRole == ADMIN">
                    <input type="submit" value="Reset" (click)="resetFilters()" class="btn btn-warning btn-block">
                </div>
            </div>
        </form>
    </div>
    <div class="card-body">
        <div class="table-responsive">
            <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Email</th>
                        <th>Phone</th>
                        <th>Designation</th>
                        <th *ngIf="userRole == ADMIN">Company</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    <tr *ngFor="let employee of employees | paginate: { itemsPerPage: 10, currentPage: p }">
                        <td><a [routerLink]="" (click)="viewEmployee(employee.employee_id)">{{employee.full_name}}</a>
                        </td>
                        <td>{{employee.email}}</td>
                        <td>{{employee.phone}}</td>
                        <td>{{employee.designation}}</td>
                        <td *ngIf="userRole == ADMIN">{{employee.company}}</td>
                        <td>
                            <span *ngIf="(!employee.user_id && userRole != ADMIN) || userRole == ADMIN"><a [routerLink]="" data-toggle="modal"
                                    data-target="#createUser" (click)="createUserForm(employee)"><i
                                        class="fa fa-user text-primary mr-2" aria-hidden="true"></i></a></span>
                            <span><a [routerLink]="" (click)="viewEmployee(employee.employee_id)" data-toggle="tooltip"
                                    title="View"><i class="fa fa-eye text-info mr-2" aria-hidden="true"></i></a></span>
                            <span><a [routerLink]="" data-toggle="modal" data-target="#addNewEmployee"
                                    (click)="editEmployee(employee)"><i class="fa fa-edit mr-2"
                                        aria-hidden="true"></i></a></span>
                            <span>
                                <a mwlConfirmationPopover [popoverTitle]="popoverTitle"
                                    [popoverMessage]="popoverMessage" placement="bottom"
                                    (confirm)="deleteEmployee(employee.employee_id)" (cancel)="cancelClicked = true"
                                    data-toggle="tooltip" title="Delete"><i class="fa fa-trash text-danger mr-2"
                                        aria-hidden="true"></i>
                                </a>
                            </span>
                        </td>
                    </tr>
                    <tr *ngIf="employees == ''">
                        <td colspan="6" class="text-center">No Records Found</td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div class="row d-flex justify-content-center">
            <pagination-controls *ngIf="employees!=''" class="my-pagination" (pageChange)="p = $event">
            </pagination-controls>
        </div>
    </div>
</div>


<!-----------Add New Company Form Modal------------------------>
<div id="addNewEmployee" class="modal fade" role="dialog">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <h6 class="modal-title">Add New Employee</h6>
                <button #closeBtn type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <form class="user" (submit)="addorEditEmployee()" [formGroup]="NewEmployeeForm">
                    <div class="form-group row">
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>Employee Name:</label>
                            <input formControlName="full_name" type="text" class="form-control form-control-user"
                                id="emp_full_name">
                            <div *ngIf="submitted && formControls.full_name.errors" class="errors">
                                <div *ngIf="formControls.full_name.errors.required">Employee Name is required</div>
                            </div>
                        </div>
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>Email:</label>
                            <input formControlName="email" type="text" class="form-control form-control-user"
                                id="email">
                            <div *ngIf="submitted && formControls.email.errors" class="errors">
                                <div *ngIf="formControls.email.errors.required">Email is required</div>
                                <div *ngIf="formControls.email.errors.pattern">Email must be a valid email address</div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>Phone:</label>
                            <input formControlName="phone" type="number" class="form-control form-control-user"
                                id="phone">
                            <div *ngIf="submitted && formControls.phone.errors" class="errors">
                                <div *ngIf="formControls.phone.errors.required">Phone is required</div>
                            </div>
                        </div>
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>Designation:</label>
                            <select formControlName="designation_id" class="form-control dropdown"
                                (change)="designationSelected($event)">
                                <option *ngFor="let d of designations;let index=i" [attr.data-role]="d.user_role" value="{{d.designation_id}}">
                                    {{d.designation}}</option>
                            </select>
                            <div *ngIf="submitted && formControls.designation_id.errors" class="errors">
                                <div *ngIf="formControls.designation_id.errors.required">Designation is required</div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div *ngIf="userRole == ADMIN" class="col-sm-6 mb-3 mb-sm-0">
                            <label>Company:</label>
                            <select formControlName="company_id" class="form-control dropdown" id="company"
                                (change)="companySelected($event.target.value)">
                                <option *ngFor="let company of companies;" value="{{company.company_id}}">
                                    {{company.name}}</option>
                            </select>
                            <div *ngIf="submitted && formControls.company_id.errors" class="errors">
                                <div *ngIf="formControls.company_id.errors.required">Company is required</div>
                            </div>
                        </div>
                        <div *ngIf="show_unit == true" class="col-sm-6 mb-3 mb-sm-0">
                            <label>Unit:</label>
                            <select formControlName="unit_id" class="form-control dropdown" id="unit">
                                <option *ngFor="let u of units;" value="{{u.unit_id}}">{{u.unit_name}}</option>
                            </select>
                            <div *ngIf="submitted && formControls.unit_id.errors" class="errors">
                                <div *ngIf="formControls.unit_id.errors.required">Unit is required</div>
                            </div>
                        </div>
                        <div *ngIf="show_department == true" class="col-sm-6 mb-3 mb-sm-0">
                            <label>Department:</label>
                            <select formControlName="department_id" class="form-control dropdown" id="unit">
                                <option *ngFor="let d of departments;" value="{{d.dept_id}}">{{d.dept_name}}</option>
                            </select>
                            <div *ngIf="submitted && formControls.department_id.errors" class="errors">
                                <div *ngIf="formControls.department_id.errors.required">Department is required</div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>Address:</label>
                            <input formControlName="address" type="text" class="form-control form-control-user"
                                id="address">
                            <div *ngIf="submitted && formControls.address.errors" class="errors">
                                <div *ngIf="formControls.address.errors.required">Address Name is required</div>
                            </div>
                        </div>
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>City:</label>
                            <input formControlName="city" type="text" class="form-control form-control-user" id="city">
                            <div *ngIf="submitted && formControls.city.errors" class="errors">
                                <div *ngIf="formControls.city.errors.required">City is required</div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>Country:</label>
                            <input formControlName="country" type="text" class="form-control form-control-user"
                                id="country">
                            <div *ngIf="submitted && formControls.country.errors" class="errors">
                                <div *ngIf="formControls.country.errors.required">Country is required</div>
                            </div>
                        </div>
                        <div class="col-sm-6 mb-3 mb-sm-0">
                            <label>Zip:</label>
                            <input formControlName="zip" type="number" class="form-control form-control-user" id="zip">
                            <div *ngIf="submitted && formControls.zip.errors" class="errors">
                                <div *ngIf="formControls.zip.errors.required">Zip is required</div>
                                <div *ngIf="formControls.zip.errors.pattern">Enter must be a valid zip number</div>
                            </div>
                        </div>
                    </div>
                    <hr>
                    <div class="form-group row">
                        <div class="col-sm-4 mb-3 mb-sm-0">
                        </div>
                        <div class="col-sm-4 mb-3 mb-sm-0">
                            <input type="submit" value="submit" class="btn btn-main btn-user btn-block">
                        </div>
                    </div>

                </form>
            </div>
        </div>

    </div>
</div>

<!-----------Create User Form Modal------------------------>
<div id="createUser" class="modal fade" role="dialog">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <h6 class="modal-title">Create / Edit User</h6>
                <button #closeUserFormBtn type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <form class="user" (submit)="createorEditUser()" [formGroup]="userForm">
                    <div class="form-group row">
                        <div class="col-sm-12 mb-3">
                            <label>Employee Name:</label>
                            <input readonly formControlName="full_name" type="text"
                                class="form-control form-control-user" id="full_name">
                        </div>
                        <div class="col-sm-12 mb-3">
                            <label>Username:</label>
                            <input formControlName="username" type="text" class="form-control form-control-user"
                                id="username">
                            <div *ngIf="submitted && formControl.username.errors" class="errors">
                                <div *ngIf="formControl.username.errors.required">Username is required</div>
                            </div>
                        </div>
                        <div class="col-sm-12 mb-3">
                            <label>Password:</label>
                            <input formControlName="password" type="password" class="form-control form-control-user"
                                id="password1">
                            <div *ngIf="submitted && formControl.password.errors" class="errors">
                                <div *ngIf="formControl.password.errors.required">Password is required</div>
                            </div>
                        </div>
                    </div>
                    <hr>
                    <div class="form-group row">
                        <div class="col-sm-4 mb-3 mb-sm-0">
                        </div>
                        <div class="col-sm-4 mb-3 mb-sm-0">
                            <input type="submit" value="submit" class="btn btn-main btn-user btn-block">
                        </div>
                    </div>

                </form>
            </div>
        </div>

    </div>
</div>

<app-view-employee></app-view-employee>